diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_eay.c openssl-1.0.0q/crypto/rsa/rsa_eay.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_eay.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_eay.c	2017-04-25 16:23:40.650620676 +0200
@@ -109,47 +109,72 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/rand.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 #ifndef RSA_NULL
+#if !defined USE_OPENSSL_CERTIFICATE_VERIFICATION || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 
 static int RSA_eay_public_encrypt(int flen, const unsigned char *from,
 		unsigned char *to, RSA *rsa,int padding);
 static int RSA_eay_private_encrypt(int flen, const unsigned char *from,
 		unsigned char *to, RSA *rsa,int padding);
+
+#endif
+
 static int RSA_eay_public_decrypt(int flen, const unsigned char *from,
 		unsigned char *to, RSA *rsa,int padding);
+
+#if !defined OPERA_SMALL_VERSION || defined SSL_PRIVATE_KEY_DECRYPT || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 static int RSA_eay_private_decrypt(int flen, const unsigned char *from,
 		unsigned char *to, RSA *rsa,int padding);
+#endif
+
 static int RSA_eay_mod_exp(BIGNUM *r0, const BIGNUM *i, RSA *rsa, BN_CTX *ctx);
 static int RSA_eay_init(RSA *rsa);
 static int RSA_eay_finish(RSA *rsa);
-static RSA_METHOD rsa_pkcs1_eay_meth={
-	"Eric Young's PKCS#1 RSA",
-	RSA_eay_public_encrypt,
-	RSA_eay_public_decrypt, /* signature verification */
-	RSA_eay_private_encrypt, /* signing */
-	RSA_eay_private_decrypt,
-	RSA_eay_mod_exp,
-	BN_mod_exp_mont, /* XXX probably we should not use Montgomery if  e == 3 */
-	RSA_eay_init,
-	RSA_eay_finish,
-	0, /* flags */
-	NULL,
-	0, /* rsa_sign */
-	0, /* rsa_verify */
-	NULL /* rsa_keygen */
-	};
+
+OPENSSL_PREFIX_CONST_ITEM(static, RSA_METHOD, rsa_pkcs1_eay_meth, libopeay)
+	CONST_ITEM_ENTRY_START(name, OPERA_OPENSSL_STRINGS("Eric Young's PKCS#1 RSA"))
+#if !defined USE_OPENSSL_CERTIFICATE_VERIFICATION || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+	CONST_ITEM_ENTRY_SINGLE(rsa_pub_enc, RSA_eay_public_encrypt)
+#else
+	CONST_ITEM_ENTRY_SINGLE(rsa_pub_enc, 0)
+#endif
+	CONST_ITEM_ENTRY_SINGLE(rsa_pub_dec, RSA_eay_public_decrypt) /* signature verification */
+#if !defined USE_OPENSSL_CERTIFICATE_VERIFICATION || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+	CONST_ITEM_ENTRY_SINGLE(rsa_priv_enc, RSA_eay_private_encrypt)
+#else
+	CONST_ITEM_ENTRY_SINGLE(rsa_priv_enc, 0) /* signing */
+#endif
+#if !defined OPERA_SMALL_VERSION || defined SSL_PRIVATE_KEY_DECRYPT || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+	CONST_ITEM_ENTRY_SINGLE(rsa_priv_dec, RSA_eay_private_decrypt)
+#else
+	CONST_ITEM_ENTRY_SINGLE(rsa_priv_dec, NULL)
+#endif
+	CONST_ITEM_ENTRY_SINGLE(rsa_mod_exp, RSA_eay_mod_exp)
+	CONST_ITEM_ENTRY_SINGLE(bn_mod_exp, BN_mod_exp_mont) /* XXX probably we should not use Montgomery if  e == 3 */
+	CONST_ITEM_ENTRY_SINGLE(init, RSA_eay_init)
+	CONST_ITEM_ENTRY_SINGLE(finish, RSA_eay_finish)
+	CONST_ITEM_ENTRY_SINGLE(flags, 0)
+	CONST_ITEM_ENTRY_SINGLE(app_data, NULL)
+	CONST_ITEM_ENTRY_SINGLE(rsa_sign, 0)
+	CONST_ITEM_ENTRY_SINGLE(rsa_verify, 0)
+	CONST_ITEM_ENTRY_SINGLE(rsa_keygen, NULL)
+	CONST_ITEM_ENTRY_END;
 
 const RSA_METHOD *RSA_PKCS1_SSLeay(void)
 	{
-	return(&rsa_pkcs1_eay_meth);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(rsa_pkcs1_eay_meth));
 	}
 
+#if !defined USE_OPENSSL_CERTIFICATE_VERIFICATION || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 static int RSA_eay_public_encrypt(int flen, const unsigned char *from,
 	     unsigned char *to, RSA *rsa, int padding)
 	{
@@ -185,29 +210,39 @@
 	f = BN_CTX_get(ctx);
 	ret = BN_CTX_get(ctx);
 	num=BN_num_bytes(rsa->n);
-	buf = OPENSSL_malloc(num);
+	buf = (unsigned char *) OPENSSL_malloc(num);
 	if (!f || !ret || !buf)
 		{
 		RSAerr(RSA_F_RSA_EAY_PUBLIC_ENCRYPT,ERR_R_MALLOC_FAILURE);
 		goto err;
 		}
 
+#ifdef VALGRIND
+	op_memset(buf,0,num);
+#endif
+
 	switch (padding)
 		{
 	case RSA_PKCS1_PADDING:
 		i=RSA_padding_add_PKCS1_type_2(buf,num,from,flen);
 		break;
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_SHA
 	case RSA_PKCS1_OAEP_PADDING:
 	        i=RSA_padding_add_PKCS1_OAEP(buf,num,from,flen,NULL,0);
 		break;
 #endif
+#endif
+#if !defined OPERA_SMALL_VERSION || defined SSL_2_0_SUPPORT
 	case RSA_SSLV23_PADDING:
 		i=RSA_padding_add_SSLv23(buf,num,from,flen);
 		break;
+#endif
+#ifndef OPERA_SMALL_VERSION
 	case RSA_NO_PADDING:
 		i=RSA_padding_add_none(buf,num,from,flen);
 		break;
+#endif
 	default:
 		RSAerr(RSA_F_RSA_EAY_PUBLIC_ENCRYPT,RSA_R_UNKNOWN_PADDING_TYPE);
 		goto err;
@@ -251,7 +286,9 @@
 		}
 	return(r);
 	}
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 static BN_BLINDING *rsa_get_blinding(RSA *rsa, int *local, BN_CTX *ctx)
 {
 	BN_BLINDING *ret;
@@ -345,6 +382,7 @@
 	 */
 	return BN_BLINDING_invert_ex(f, unblind, b, ctx);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 /* signing */
 static int RSA_eay_private_encrypt(int flen, const unsigned char *from,
@@ -354,19 +392,21 @@
 	int i,j,k,num=0,r= -1;
 	unsigned char *buf=NULL;
 	BN_CTX *ctx=NULL;
+#ifndef OPERA_SMALL_VERSION
 	int local_blinding = 0;
 	/* Used only if the blinding structure is shared. A non-NULL unblind
 	 * instructs rsa_blinding_convert() and rsa_blinding_invert() to store
 	 * the unblinding factor outside the blinding structure. */
 	BIGNUM *unblind = NULL;
 	BN_BLINDING *blinding = NULL;
+#endif
 
 	if ((ctx=BN_CTX_new()) == NULL) goto err;
 	BN_CTX_start(ctx);
 	f   = BN_CTX_get(ctx);
 	ret = BN_CTX_get(ctx);
 	num = BN_num_bytes(rsa->n);
-	buf = OPENSSL_malloc(num);
+	buf = (unsigned char *) OPENSSL_malloc(num);
 	if(!f || !ret || !buf)
 		{
 		RSAerr(RSA_F_RSA_EAY_PRIVATE_ENCRYPT,ERR_R_MALLOC_FAILURE);
@@ -378,12 +418,14 @@
 	case RSA_PKCS1_PADDING:
 		i=RSA_padding_add_PKCS1_type_1(buf,num,from,flen);
 		break;
+#ifndef OPERA_SMALL_VERSION
 	case RSA_X931_PADDING:
 		i=RSA_padding_add_X931(buf,num,from,flen);
 		break;
 	case RSA_NO_PADDING:
 		i=RSA_padding_add_none(buf,num,from,flen);
 		break;
+#endif
 	case RSA_SSLV23_PADDING:
 	default:
 		RSAerr(RSA_F_RSA_EAY_PRIVATE_ENCRYPT,RSA_R_UNKNOWN_PADDING_TYPE);
@@ -400,6 +442,7 @@
 		goto err;
 		}
 
+#ifndef OPERA_SMALL_VERSION
 	if (!(rsa->flags & RSA_FLAG_NO_BLINDING))
 		{
 		blinding = rsa_get_blinding(rsa, &local_blinding, ctx);
@@ -420,6 +463,7 @@
 		if (!rsa_blinding_convert(blinding, f, unblind, ctx))
 			goto err;
 		}
+#endif
 
 	if ( (rsa->flags & RSA_FLAG_EXT_PKEY) ||
 		((rsa->p != NULL) &&
@@ -452,10 +496,13 @@
 				rsa->_method_mod_n)) goto err;
 		}
 
+#ifndef OPERA_SMALL_VERSION
 	if (blinding)
 		if (!rsa_blinding_invert(blinding, ret, unblind, ctx))
 			goto err;
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 	if (padding == RSA_X931_PADDING)
 		{
 		BN_sub(f, rsa->n, ret);
@@ -465,6 +512,7 @@
 			res = ret;
 		}
 	else
+#endif
 		res = ret;
 
 	/* put in leading 0 bytes if the number is less than the
@@ -489,6 +537,7 @@
 	return(r);
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined SSL_PRIVATE_KEY_DECRYPT || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 static int RSA_eay_private_decrypt(int flen, const unsigned char *from,
 	     unsigned char *to, RSA *rsa, int padding)
 	{
@@ -497,19 +546,21 @@
 	unsigned char *p;
 	unsigned char *buf=NULL;
 	BN_CTX *ctx=NULL;
+#ifndef OPERA_SMALL_VERSION
 	int local_blinding = 0;
 	/* Used only if the blinding structure is shared. A non-NULL unblind
 	 * instructs rsa_blinding_convert() and rsa_blinding_invert() to store
 	 * the unblinding factor outside the blinding structure. */
 	BIGNUM *unblind = NULL;
 	BN_BLINDING *blinding = NULL;
+#endif
 
 	if((ctx = BN_CTX_new()) == NULL) goto err;
 	BN_CTX_start(ctx);
 	f   = BN_CTX_get(ctx);
 	ret = BN_CTX_get(ctx);
 	num = BN_num_bytes(rsa->n);
-	buf = OPENSSL_malloc(num);
+	buf = (unsigned char *) OPENSSL_malloc(num);
 	if(!f || !ret || !buf)
 		{
 		RSAerr(RSA_F_RSA_EAY_PRIVATE_DECRYPT,ERR_R_MALLOC_FAILURE);
@@ -533,6 +584,7 @@
 		goto err;
 		}
 
+#ifndef OPERA_SMALL_VERSION
 	if (!(rsa->flags & RSA_FLAG_NO_BLINDING))
 		{
 		blinding = rsa_get_blinding(rsa, &local_blinding, ctx);
@@ -553,6 +605,7 @@
 		if (!rsa_blinding_convert(blinding, f, unblind, ctx))
 			goto err;
 		}
+#endif
 
 	/* do the decrypt */
 	if ( (rsa->flags & RSA_FLAG_EXT_PKEY) ||
@@ -585,9 +638,11 @@
 		  goto err;
 		}
 
+#ifndef OPERA_SMALL_VERSION
 	if (blinding)
 		if (!rsa_blinding_invert(blinding, ret, unblind, ctx))
 			goto err;
+#endif
 
 	p=buf;
 	j=BN_bn2bin(ret,p); /* j is only used with no-padding mode */
@@ -597,17 +652,21 @@
 	case RSA_PKCS1_PADDING:
 		r=RSA_padding_check_PKCS1_type_2(to,num,buf,j,num);
 		break;
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_SHA
         case RSA_PKCS1_OAEP_PADDING:
 	        r=RSA_padding_check_PKCS1_OAEP(to,num,buf,j,num,NULL,0);
                 break;
 #endif
+#endif
+#ifndef OPERA_SMALL_VERSION
  	case RSA_SSLV23_PADDING:
 		r=RSA_padding_check_SSLv23(to,num,buf,j,num);
 		break;
 	case RSA_NO_PADDING:
 		r=RSA_padding_check_none(to,num,buf,j,num);
 		break;
+#endif
 	default:
 		RSAerr(RSA_F_RSA_EAY_PRIVATE_DECRYPT,RSA_R_UNKNOWN_PADDING_TYPE);
 		goto err;
@@ -628,6 +687,7 @@
 		}
 	return(r);
 	}
+#endif
 
 /* signature verification */
 static int RSA_eay_public_decrypt(int flen, const unsigned char *from,
@@ -666,7 +726,7 @@
 	f = BN_CTX_get(ctx);
 	ret = BN_CTX_get(ctx);
 	num=BN_num_bytes(rsa->n);
-	buf = OPENSSL_malloc(num);
+	buf = (unsigned char *) OPENSSL_malloc(num);
 	if(!f || !ret || !buf)
 		{
 		RSAerr(RSA_F_RSA_EAY_PUBLIC_DECRYPT,ERR_R_MALLOC_FAILURE);
@@ -707,12 +767,14 @@
 	case RSA_PKCS1_PADDING:
 		r=RSA_padding_check_PKCS1_type_1(to,num,buf,i,num);
 		break;
+#ifndef OPERA_SMALL_VERSION
 	case RSA_X931_PADDING:
 		r=RSA_padding_check_X931(to,num,buf,i,num);
 		break;
 	case RSA_NO_PADDING:
 		r=RSA_padding_check_none(to,num,buf,i,num);
 		break;
+#endif
 	default:
 		RSAerr(RSA_F_RSA_EAY_PUBLIC_DECRYPT,RSA_R_UNKNOWN_PADDING_TYPE);
 		goto err;
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_err.c openssl-1.0.0q/crypto/rsa/rsa_err.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_err.c	2017-04-25 16:23:40.651620245 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/rsa.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_gen.c openssl-1.0.0q/crypto/rsa/rsa_gen.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_gen.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_gen.c	2017-04-25 16:23:40.651620245 +0200
@@ -56,15 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
-
 /* NB: these functions have been "upgraded", the deprecated versions (which are
  * compatibility wrappers using these functions) are in rsa_depr.c.
  * - Geoff
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 
@@ -216,4 +218,3 @@
 
 	return ok;
 	}
-
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_lib.c openssl-1.0.0q/crypto/rsa/rsa_lib.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_lib.c	2017-04-25 16:23:40.652620372 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
-#include "cryptlib.h"
 #include <openssl/lhash.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
@@ -67,9 +69,13 @@
 #include <openssl/engine.h>
 #endif
 
-const char RSA_version[]="RSA" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char RSA_version[]="RSA" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 static const RSA_METHOD *default_RSA_meth=NULL;
+#endif
 
 RSA *RSA_new(void)
 	{
@@ -78,13 +84,16 @@
 	return r;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void RSA_set_default_method(const RSA_METHOD *meth)
 	{
 	default_RSA_meth = meth;
 	}
+#endif
 
 const RSA_METHOD *RSA_get_default_method(void)
 	{
+#ifndef OPERA_SMALL_VERSION
 	if (default_RSA_meth == NULL)
 		{
 #ifdef RSA_NULL
@@ -99,8 +108,12 @@
 		}
 
 	return default_RSA_meth;
+#else
+	return RSA_PKCS1_SSLeay();
+#endif
 	}
 
+#ifndef OPERA_SMALL_VERSION
 const RSA_METHOD *RSA_get_method(const RSA *rsa)
 	{
 	return rsa->meth;
@@ -124,6 +137,7 @@
 	if (meth->init) meth->init(rsa);
 	return 1;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 RSA *RSA_new_method(ENGINE *engine)
 	{
@@ -137,6 +151,7 @@
 		}
 
 	ret->meth = RSA_get_default_method();
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_ENGINE
 	if (engine)
 		{
@@ -163,6 +178,9 @@
 			}
 		}
 #endif
+#else
+	ret->engine = NULL;
+#endif // !OPERA_SMALL_VERSION
 
 	ret->pad=0;
 	ret->version=0;
@@ -178,9 +196,11 @@
 	ret->_method_mod_n=NULL;
 	ret->_method_mod_p=NULL;
 	ret->_method_mod_q=NULL;
+#ifndef OPERA_SMALL_VERSION
 	ret->blinding=NULL;
 	ret->mt_blinding=NULL;
 	ret->bignum_data=NULL;
+#endif
 	ret->flags=ret->meth->flags;
 	if (!CRYPTO_new_ex_data(CRYPTO_EX_INDEX_RSA, ret, &ret->ex_data))
 		{
@@ -241,9 +261,11 @@
 	if (r->dmp1 != NULL) BN_clear_free(r->dmp1);
 	if (r->dmq1 != NULL) BN_clear_free(r->dmq1);
 	if (r->iqmp != NULL) BN_clear_free(r->iqmp);
+#ifndef OPERA_SMALL_VERSION
 	if (r->blinding != NULL) BN_BLINDING_free(r->blinding);
 	if (r->mt_blinding != NULL) BN_BLINDING_free(r->mt_blinding);
 	if (r->bignum_data != NULL) OPENSSL_free_locked(r->bignum_data);
+#endif
 	OPENSSL_free(r);
 	}
 
@@ -314,6 +336,7 @@
 	return((r == NULL)?0:r->meth->flags);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void RSA_blinding_off(RSA *rsa)
 	{
 	if (rsa->blinding != NULL)
@@ -436,7 +459,9 @@
 
 	return ret;
 }
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 int RSA_memory_lock(RSA *r)
 	{
 	int i,j,k,off;
@@ -456,7 +481,7 @@
 	j=1;
 	for (i=0; i<6; i++)
 		j+= (*t[i])->top;
-	if ((p=OPENSSL_malloc_locked((off+j)*sizeof(BN_ULONG))) == NULL)
+	if ((p=(char*)OPENSSL_malloc_locked((off+j)*sizeof(BN_ULONG))) == NULL)
 		{
 		RSAerr(RSA_F_RSA_MEMORY_LOCK,ERR_R_MALLOC_FAILURE);
 		return(0);
@@ -467,10 +492,10 @@
 		{
 		b= *(t[i]);
 		*(t[i])= &(bn[i]);
-		memcpy((char *)&(bn[i]),(char *)b,sizeof(BIGNUM));
+		op_memcpy((char *)&(bn[i]),(char *)b,sizeof(BIGNUM));
 		bn[i].flags=BN_FLG_STATIC_DATA;
 		bn[i].d=ul;
-		memcpy((char *)ul,b->d,sizeof(BN_ULONG)*b->top);
+		op_memcpy((char *)ul,b->d,sizeof(BN_ULONG)*b->top);
 		ul+=b->top;
 		BN_clear_free(b);
 		}
@@ -481,3 +506,4 @@
 	r->bignum_data=p;
 	return(1);
 	}
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_none.c openssl-1.0.0q/crypto/rsa/rsa_none.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_none.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_none.c	2017-04-25 16:23:40.653620220 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/rand.h>
@@ -77,7 +80,7 @@
 		return(0);
 		}
 	
-	memcpy(to,from,(unsigned int)flen);
+	op_memcpy(to,from,(unsigned int)flen);
 	return(1);
 	}
 
@@ -91,8 +94,9 @@
 		return(-1);
 		}
 
-	memset(to,0,tlen-flen);
-	memcpy(to+tlen-flen,from,flen);
+	op_memset(to,0,tlen-flen);
+	op_memcpy(to+tlen-flen,from,flen);
 	return(tlen);
 	}
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_null.c openssl-1.0.0q/crypto/rsa/rsa_null.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_null.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_null.c	2017-04-25 16:23:40.654621185 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_oaep.c openssl-1.0.0q/crypto/rsa/rsa_oaep.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_oaep.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_oaep.c	2017-04-25 16:23:40.654621185 +0200
@@ -21,8 +21,11 @@
 #include "constant_time_locl.h"
 
 #if !defined(OPENSSL_NO_SHA) && !defined(OPENSSL_NO_SHA1)
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/evp.h>
@@ -58,19 +61,19 @@
 	db = to + SHA_DIGEST_LENGTH + 1;
 
 	EVP_Digest((void *)param, plen, db, NULL, EVP_sha1(), NULL);
-	memset(db + SHA_DIGEST_LENGTH, 0,
+	op_memset(db + SHA_DIGEST_LENGTH, 0,
 		emlen - flen - 2 * SHA_DIGEST_LENGTH - 1);
 	db[emlen - flen - SHA_DIGEST_LENGTH - 1] = 0x01;
-	memcpy(db + emlen - flen - SHA_DIGEST_LENGTH, from, (unsigned int) flen);
+	op_memcpy(db + emlen - flen - SHA_DIGEST_LENGTH, from, (unsigned int) flen);
 	if (RAND_bytes(seed, SHA_DIGEST_LENGTH) <= 0)
 		return 0;
 #ifdef PKCS_TESTVECT
-	memcpy(seed,
+	op_memcpy(seed,
 	   "\xaa\xfd\x12\xf6\x59\xca\xe6\x34\x89\xb4\x79\xe5\x07\x6d\xde\xc2\xf0\x6c\xb5\x8f",
 	   20);
 #endif
 
-	dbmask = OPENSSL_malloc(emlen - SHA_DIGEST_LENGTH);
+	dbmask = (unsigned char *)OPENSSL_malloc(emlen - SHA_DIGEST_LENGTH);
 	if (dbmask == NULL)
 		{
 		RSAerr(RSA_F_RSA_PADDING_ADD_PKCS1_OAEP, ERR_R_MALLOC_FAILURE);
@@ -118,8 +121,8 @@
 		goto decoding_err;
 
 	dblen = num - SHA_DIGEST_LENGTH - 1;
-	db = OPENSSL_malloc(dblen);
-	em = OPENSSL_malloc(num);
+	db = (unsigned char *)OPENSSL_malloc(dblen);
+	em = (unsigned char *)OPENSSL_malloc(num);
 	if (db == NULL || em == NULL)
 		{
 		RSAerr(RSA_F_RSA_PADDING_CHECK_PKCS1_OAEP, ERR_R_MALLOC_FAILURE);
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_pk1.c openssl-1.0.0q/crypto/rsa/rsa_pk1.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_pk1.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_pk1.c	2017-04-25 16:23:40.655621871 +0200
@@ -58,8 +58,10 @@
 
 #include "constant_time_locl.h"
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/rand.h>
@@ -83,10 +85,10 @@
 
 	/* pad out with 0xff data */
 	j=tlen-3-flen;
-	memset(p,0xff,j);
+	op_memset(p,0xff,j);
 	p+=j;
 	*(p++)='\0';
-	memcpy(p,from,(unsigned int)flen);
+	op_memcpy(p,from,(unsigned int)flen);
 	return(1);
 	}
 
@@ -137,11 +139,12 @@
 		RSAerr(RSA_F_RSA_PADDING_CHECK_PKCS1_TYPE_1,RSA_R_DATA_TOO_LARGE);
 		return(-1);
 		}
-	memcpy(to,p,(unsigned int)j);
+	op_memcpy(to,p,(unsigned int)j);
 
 	return(j);
 	}
 
+#if !defined USE_OPENSSL_CERTIFICATE_VERIFICATION || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 int RSA_padding_add_PKCS1_type_2(unsigned char *to, int tlen,
 	     const unsigned char *from, int flen)
 	{
@@ -176,10 +179,12 @@
 
 	*(p++)='\0';
 
-	memcpy(p,from,(unsigned int)flen);
+	op_memcpy(p,from,(unsigned int)flen);
 	return(1);
 	}
+#endif
 
+#if defined(NEED_LIBOPEAY_ELGAMAL) || defined SSL_PRIVATE_KEY_DECRYPT || defined EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
 int RSA_padding_check_PKCS1_type_2(unsigned char *to, int tlen,
 	     const unsigned char *from, int flen, int num)
 	{
@@ -216,7 +221,7 @@
 	 *
 	 * TODO(emilia): Consider porting BN_bn2bin_padded from BoringSSL.
 	 */
-	memcpy(em + num - flen, from, flen);
+	op_memcpy(em + num - flen, from, flen);
 
 	good = constant_time_is_zero(em[0]);
 	good &= constant_time_eq(em[1], 2);
@@ -258,7 +263,7 @@
 		goto err;
 		}
 
-	memcpy(to, em + msg_index, mlen);
+	op_memcpy(to, em + msg_index, mlen);
 
 err:
 	if (em != NULL)
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_pmeth.c openssl-1.0.0q/crypto/rsa/rsa_pmeth.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_pmeth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_pmeth.c	2017-04-25 16:23:40.656620322 +0200
@@ -56,15 +56,20 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/rsa.h>
 #include <openssl/bn.h>
 #include <openssl/evp.h>
-#include "evp_locl.h"
+#include "../evp/evp_locl.h"
 #include "rsa_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* RSA pkey context structure */
 
@@ -88,7 +93,7 @@
 static int pkey_rsa_init(EVP_PKEY_CTX *ctx)
 	{
 	RSA_PKEY_CTX *rctx;
-	rctx = OPENSSL_malloc(sizeof(RSA_PKEY_CTX));
+	rctx = (RSA_PKEY_CTX *)OPENSSL_malloc(sizeof(RSA_PKEY_CTX));
 	if (!rctx)
 		return 0;
 	rctx->nbits = 1024;
@@ -111,8 +116,8 @@
 	RSA_PKEY_CTX *dctx, *sctx;
 	if (!pkey_rsa_init(dst))
 		return 0;
-       	sctx = src->data;
-	dctx = dst->data;
+       	sctx = (RSA_PKEY_CTX *)src->data;
+	dctx = (RSA_PKEY_CTX *)dst->data;
 	dctx->nbits = sctx->nbits;
 	if (sctx->pub_exp)
 		{
@@ -129,7 +134,7 @@
 	{
 	if (ctx->tbuf)
 		return 1;
-	ctx->tbuf = OPENSSL_malloc(EVP_PKEY_size(pk->pkey));
+	ctx->tbuf = (unsigned char *)OPENSSL_malloc(EVP_PKEY_size(pk->pkey));
 	if (!ctx->tbuf)
 		return 0;
 	return 1;
@@ -137,7 +142,7 @@
 
 static void pkey_rsa_cleanup(EVP_PKEY_CTX *ctx)
 	{
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	if (rctx)
 		{
 		if (rctx->pub_exp)
@@ -152,7 +157,7 @@
 					const unsigned char *tbs, size_t tbslen)
 	{
 	int ret;
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	RSA *rsa = ctx->pkey->pkey.rsa;
 
 	if (rctx->md)
@@ -210,7 +215,7 @@
 					const unsigned char *sig, size_t siglen)
 	{
 	int ret;
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 
 	if (rctx->md)
 		{
@@ -266,7 +271,7 @@
 					const unsigned char *sig, size_t siglen,
 					const unsigned char *tbs, size_t tbslen)
 	{
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	RSA *rsa = ctx->pkey->pkey.rsa;
 	size_t rslen;
 	if (rctx->md)
@@ -321,7 +326,7 @@
 					const unsigned char *in, size_t inlen)
 	{
 	int ret;
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	ret = RSA_public_encrypt(inlen, in, out, ctx->pkey->pkey.rsa,
 							rctx->pad_mode);
 	if (ret < 0)
@@ -335,7 +340,7 @@
 					const unsigned char *in, size_t inlen)
 	{
 	int ret;
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	ret = RSA_private_decrypt(inlen, in, out, ctx->pkey->pkey.rsa,
 							rctx->pad_mode);
 	if (ret < 0)
@@ -372,7 +377,7 @@
 
 static int pkey_rsa_ctrl(EVP_PKEY_CTX *ctx, int type, int p1, void *p2)
 	{
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	switch (type)
 		{
 		case EVP_PKEY_CTRL_RSA_PADDING:
@@ -426,13 +431,13 @@
 		case EVP_PKEY_CTRL_RSA_KEYGEN_PUBEXP:
 		if (!p2)
 			return -2;
-		rctx->pub_exp = p2;
+		rctx->pub_exp = (BIGNUM *)p2;
 		return 1;
 
 		case EVP_PKEY_CTRL_MD:
-		if (!check_padding_md(p2, rctx->pad_mode))
+		if (!check_padding_md((const EVP_MD *)p2, rctx->pad_mode))
 			return 0;
-		rctx->md = p2;
+		rctx->md = (const EVP_MD *)p2;
 		return 1;
 
 		case EVP_PKEY_CTRL_DIGESTINIT:
@@ -522,7 +527,7 @@
 static int pkey_rsa_keygen(EVP_PKEY_CTX *ctx, EVP_PKEY *pkey)
 	{
 	RSA *rsa = NULL;
-	RSA_PKEY_CTX *rctx = ctx->data;
+	RSA_PKEY_CTX *rctx = (RSA_PKEY_CTX *)ctx->data;
 	BN_GENCB *pcb, cb;
 	int ret;
 	if (!rctx->pub_exp)
@@ -549,8 +554,7 @@
 	return ret;
 	}
 
-const EVP_PKEY_METHOD rsa_pkey_meth = 
-	{
+CONST_EVP_PKEY_METHOD_ITEM(rsa_pmeth__rsa_pkey_meth,
 	EVP_PKEY_RSA,
 	EVP_PKEY_FLAG_AUTOARGLEN,
 	pkey_rsa_init,
@@ -586,4 +590,4 @@
 	pkey_rsa_ctrl_str
 
 
-	};
+	);
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_pss.c openssl-1.0.0q/crypto/rsa/rsa_pss.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_pss.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_pss.c	2017-04-25 16:23:40.658620855 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/evp.h>
@@ -122,7 +125,7 @@
 		}
 	maskedDBLen = emLen - hLen - 1;
 	H = EM + maskedDBLen;
-	DB = OPENSSL_malloc(maskedDBLen);
+	DB = (unsigned char*)OPENSSL_malloc(maskedDBLen);
 	if (!DB)
 		{
 		RSAerr(RSA_F_RSA_VERIFY_PKCS1_PSS, ERR_R_MALLOC_FAILURE);
@@ -215,7 +218,7 @@
 		}
 	if (sLen > 0)
 		{
-		salt = OPENSSL_malloc(sLen);
+		salt = (unsigned char*)OPENSSL_malloc(sLen);
 		if (!salt)
 			{
 			RSAerr(RSA_F_RSA_PADDING_ADD_PKCS1_PSS,
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_saos.c openssl-1.0.0q/crypto/rsa/rsa_saos.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_saos.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_saos.c	2017-04-25 16:23:40.659621820 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/objects.h>
@@ -132,7 +134,7 @@
 	if (sig == NULL) goto err;
 
 	if (	((unsigned int)sig->length != m_len) ||
-		(memcmp(m,sig->data,m_len) != 0))
+		(op_memcmp(m,sig->data,m_len) != 0))
 		{
 		RSAerr(RSA_F_RSA_VERIFY_ASN1_OCTET_STRING,RSA_R_BAD_SIGNATURE);
 		}
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_sign.c openssl-1.0.0q/crypto/rsa/rsa_sign.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_sign.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_sign.c	2017-04-25 16:23:40.659621820 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_ssl.c openssl-1.0.0q/crypto/rsa/rsa_ssl.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_ssl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_ssl.c	2017-04-25 16:23:40.660621668 +0200
@@ -56,8 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+#if !defined OPERA_SMALL_VERSION || defined SSL_2_0_SUPPORT
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/rand.h>
@@ -94,14 +99,15 @@
 		p++;
 		}
 
-	memset(p,3,8);
+	op_memset(p,3,8);
 	p+=8;
 	*(p++)='\0';
 
-	memcpy(p,from,(unsigned int)flen);
+	op_memcpy(p,from,(unsigned int)flen);
 	return(1);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int RSA_padding_check_SSLv23(unsigned char *to, int tlen,
 	const unsigned char *from, int flen, int num)
 	{
@@ -147,8 +153,10 @@
 		RSAerr(RSA_F_RSA_PADDING_CHECK_SSLV23,RSA_R_DATA_TOO_LARGE);
 		return(-1);
 		}
-	memcpy(to,p,(unsigned int)j);
+	op_memcpy(to,p,(unsigned int)j);
 
 	return(j);
 	}
 
+#endif // !OPERA_SMALL_VERSION
+#endif // !defined OPERA_SMALL_VERSION || defined SSL_2_0_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_test.c openssl-1.0.0q/crypto/rsa/rsa_test.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_test.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_test.c	2017-04-25 16:23:40.661621516 +0200
@@ -1,7 +1,9 @@
 /* test vectors from p1ovect1.txt */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "e_os.h"
 
@@ -27,7 +29,7 @@
   key->dmp1 = BN_bin2bn(dmp1, sizeof(dmp1)-1, key->dmp1); \
   key->dmq1 = BN_bin2bn(dmq1, sizeof(dmq1)-1, key->dmq1); \
   key->iqmp = BN_bin2bn(iqmp, sizeof(iqmp)-1, key->iqmp); \
-  memcpy(c, ctext_ex, sizeof(ctext_ex) - 1); \
+  op_memcpy(c, ctext_ex, sizeof(ctext_ex) - 1); \
   return (sizeof(ctext_ex) - 1);
 
 static int key1(RSA *key, unsigned char *c)
@@ -256,7 +258,7 @@
   
 	num = RSA_private_decrypt(num, ctext, ptext, key,
 				  RSA_PKCS1_PADDING);
-	if (num != plen || memcmp(ptext, ptext_ex, num) != 0)
+	if (num != plen || op_memcmp(ptext, ptext_ex, num) != 0)
 	    {
 	    printf("PKCS#1 v1.5 decryption failed!\n");
 	    err=1;
@@ -282,12 +284,12 @@
 
 	num = RSA_private_decrypt(num, ctext, ptext, key,
 				  RSA_PKCS1_OAEP_PADDING);
-	if (num != plen || memcmp(ptext, ptext_ex, num) != 0)
+	if (num != plen || op_memcmp(ptext, ptext_ex, num) != 0)
 	    {
 	    printf("OAEP decryption (encrypted data) failed!\n");
 	    err=1;
 	    }
-	else if (memcmp(ctext, ctext_ex, num) == 0)
+	else if (op_memcmp(ctext, ctext_ex, num) == 0)
 	    printf("OAEP test vector %d passed!\n", v);
     
 	/* Different ciphertexts (rsa_oaep.c without -DPKCS_TESTVECT).
@@ -296,7 +298,7 @@
 	num = RSA_private_decrypt(clen, ctext_ex, ptext, key,
 				  RSA_PKCS1_OAEP_PADDING);
 
-	if (num != plen || memcmp(ptext, ptext_ex, num) != 0)
+	if (num != plen || op_memcmp(ptext, ptext_ex, num) != 0)
 	    {
 	    printf("OAEP decryption (test vector data) failed!\n");
 	    err=1;
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_x931.c openssl-1.0.0q/crypto/rsa/rsa_x931.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_x931.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_x931.c	2017-04-25 16:23:40.661621516 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/rand.h>
@@ -174,4 +177,3 @@
 		}
 	return -1;
 	}
-
diff -Naur openssl-1.0.0q.orig/crypto/seed/.gitignore openssl-1.0.0q/crypto/seed/.gitignore
--- openssl-1.0.0q.orig/crypto/seed/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/seed/.gitignore	2017-04-25 16:23:40.662621363 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/sha/.gitignore openssl-1.0.0q/crypto/sha/.gitignore
--- openssl-1.0.0q.orig/crypto/sha/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/.gitignore	2017-04-25 16:23:40.663622329 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha.c openssl-1.0.0q/crypto/sha/sha.c
--- openssl-1.0.0q.orig/crypto/sha/sha.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha.c	2017-04-25 16:23:40.664620500 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/sha.h>
 
 #define BUFSIZE	1024*16
